﻿using System;

namespace CSharpBuch.Kap05
{
  public class ErweiterungsMethoden
  {
    static void Main(string[] args)
    {
      Person p = new Person { Name = "Meierle", Vorname = "Paule" };
      p.Ausgabe(", ");

      string name = "Meierle";
      Console.WriteLine(name.ZeichenAnzahl());
    }
  }

  public class Person
  {
    public string Name;
    public string Vorname;

    /* diese Methode hätte Vorrang vor der Erweiterungsmethode
    public void Ausgabe(string trenner)
    {
      Console.WriteLine(Name + trenner + Vorname);
    }
    */
  }

  public static class PersonErweiterung
  {
    public static void Ausgabe(this Person pers, string trenner)
    {
      Console.WriteLine(pers.Name + trenner + pers.Vorname);
    }
  }

  public static class StringErweiterung
  {
    public static int ZeichenAnzahl(this string para)
    {
      return para.Length;
    }
  }
}