﻿using System;

namespace CSharpBuch.Kap05
{
  public class ObjekteErzeugen2
  {
    static void Main(string[] args)
    {
      Buch buch = new Buch("Märchen", "Gebrüder Grimm");
      Console.WriteLine(buch.ObjektAnzeigen());
      buch = new Buch("Mord im Orientexpress", "A. Christie", 1978);
      Console.WriteLine(buch.ObjektAnzeigen());
      Console.ReadLine();
    }
  }

  public class Buch
  {
    private string titel;
    private string autor;
    private int erscheinungsJahr;

    public Buch(string titel, int jahr) : this(titel, "", jahr)
    {
      Console.WriteLine("Konstruktor (string titel, int jahr) aufgerufen");
    }

    public Buch(string titel, string autor) : this(titel, autor, 0)
    {
      Console.WriteLine("Konstruktor (string titel, string autor) aufgerufen");
    }

    public Buch(string titel, string autor, int jahr)
    {
      Console.WriteLine("Konstruktor (string titel, string autor, int jahr) aufgerufen");

      this.titel = titel;
      this.erscheinungsJahr = jahr;
      this.autor = autor;
    }

    ~Buch()
    {
      Console.WriteLine("Buch-Objekt zerstört");
    }

    public string ObjektAnzeigen()
    {
      if (erscheinungsJahr == 0)
        return (autor + ": \"" + titel + "\", Erscheinungsjahr unbekannt");
      else if (autor == "")
        return ("\"" + titel + "\", " + erscheinungsJahr + " Autor unbekannt");
      else
        return (autor + ": \"" + titel + "\", " + erscheinungsJahr);
    }
  }
}