﻿using System;
using System.Linq;
using System.Xml;
using System.Xml.Linq;

namespace CSharpBuch.Kap31
{
  public class GruppierungLinqAbfrage
  {
    static void Main(string[] args)
    {
      XElement xmlDoc = XElement.Load("Kunden.xml");

      var kunden = from kdn in xmlDoc.Elements() group kdn by (string)kdn.Element("Ort");

      foreach (var kundeNachWohnort in kunden)
      {
        Console.WriteLine("Kunde für Wohnort: " + kundeNachWohnort.Key +
                          "\n======================================");

        foreach (var kunde in kundeNachWohnort)
          Console.WriteLine(kunde.Element("Name").Value + ", " + kunde.Element("Vorname").Value);

        Console.WriteLine();
      }
    }
  }
}